USE STD.TEXTIO.ALL;
USE WORK.file_pck.ALL;
USE WORK.arq_pck1.ALL;

ENTITY rom64x8 IS
        GENERIC(retardo: TIME:=50 ns; nombre:STRING:="datos.txt");
        PORT(direccion: IN BIT_VECTOR(5 DOWNTO 0):="000000";
             me: IN BIT:='0';
             sal_datos: OUT vector_bus:=('Z', 'Z', 'Z', 'Z','Z', 'Z', 'Z', 'Z'));
END rom64x8;

ARCHITECTURE comportamiento OF rom64x8 IS
BEGIN
PROCESS
        VARIABLE pal: memoria_nx8(0 TO 63);
        VARIABLE comienzo: BOOLEAN:=TRUE;
        VARIABLE dir_log: BIT_VECTOR(5 DOWNTO 0);
        VARIABLE dir_ent: INTEGER;

        FILE fichero: TEXT IS nombre;

BEGIN
        WAIT ON direccion, me;

        IF comienzo THEN
               cargar_rom(pal, fichero);
               comienzo:=FALSE;
        END IF;

        IF(me='1') THEN
                                   
                dir_log:=direccion;
                logico_entero(dir_log, dir_ent);


                FOR i IN 0 TO 7 LOOP
                        IF pal(dir_ent)(i)='0' THEN
                                sal_datos(i)<=TRANSPORT '0' AFTER retardo;
                        ELSE
                                sal_datos(i)<=TRANSPORT '1' AFTER retardo;
                        END IF;
                END LOOP;
        ELSE
                FOR i IN 0 TO 7 LOOP
                        sal_datos(i)<=TRANSPORT 'Z' AFTER retardo;
                END LOOP;
       END IF;

END PROCESS;
END comportamiento;


