ENTITY sum_elemental IS
        PORT(ai,bi,ci:IN BIT;sum,co:OUT BIT);
END sum_elemental;

ARCHITECTURE estructural OF sum_elemental IS

--declaracin de componetes
	COMPONENT xor2
	    PORT (e1,e2: in BIT; s: OUT BIT);
	END COMPONENT;
	COMPONENT nand2
	    PORT (e1,e2: IN BIT; s: OUT BIT);
	END COMPONENT;

--declaracin de las seales
	SIGNAL s1,s2,s3: BIT;

--indicamos donde se encuentra la arquitectura de los componentes
    FOR puerta1,puerta2: xor2 USE ENTITY WORK.xor2(comportamiento);
    FOR OTHERS: nand2 USE ENTITY WORK.nand2(comportamiento);

--realizamos las conexiones
BEGIN
	puerta1: xor2 PORT MAP (ai,bi,s1);
	puerta2: xor2 PORT MAP (s1,ci,sum);
	puerta3: nand2 PORT MAP (s1,ci,s3);
	puerta4: nand2 PORT MAP (ai,bi,s2);
	puerta5: nand2 PORT MAP (s3,s2,co);
	
END estructural;
                
