--simulacin de un buffer de 4 bits
USE WORK.arq_pack.ALL;

ENTITY buffer4 IS
	GENERIC (retardo_transferencia: TIME:=15 ns; retardo_Z:TIME:=10 ns);
	PORT (entrada: IN vector_bus; control: IN BIT:='0'; salida: OUT vector_bus);
END buffer4;

ARCHITECTURE comportamiento OF buffer4 IS
BEGIN
	PROCESS (control, entrada)
	BEGIN
		IF control='1' THEN
		   	FOR i IN 0 TO 3 LOOP
			     IF entrada(i)='1' OR entrada(i)='Z' THEN
				salida(i)<=TRANSPORT'1' AFTER retardo_transferencia;
			  	ELSE salida(i)<=TRANSPORT'0' AFTER retardo_transferencia;
			     END IF;
		   	END LOOP;
		   ELSE salida <= TRANSPORT('Z','Z','Z','Z')AFTER retardo_Z;
		END IF;
	END PROCESS;
END comportamiento;