--registro
USE WORK.arq_pack.ALL;

ENTITY registro IS
	GENERIC (retardo_carga: TIME:= 10 ns);
	PORT (entrada:IN vector_bus; control: IN BIT:='0';
		salida: OUT vector_bus:=('0','0','0','0'));
END registro;

ARCHITECTURE comportamiento OF registro IS
BEGIN
	PROCESS (control)
	VARIABLE dato:vector_bus:=('0','0','0','0');
	BEGIN
		IF (control'EVENT AND control='0') THEN
			FOR i IN 0 TO 3 LOOP
				IF entrada(i)='1' OR entrada(i)='Z' THEN
					dato(i):='1';
				   ELSE dato(i):='0';
				END IF;
			END LOOP;
		END IF;
		salida <= dato AFTER retardo_carga;
	END PROCESS;
END comportamiento;
			